/*
 * a1-i.k.c
 * Copyright (C) 2011-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <a1-types.h>
#include <e4.h>
#include <lxcast.h>

int
_x1f4_a1_keep_call(void **post_data, unsigned flags, char *used,
		   int *post_args, struct a1_instant_type *instant_data,
		   const int *link_args, unsigned line, int lock,
		   unsigned link, int call, int scale)
{
    struct a1_link_type *link_data;
    struct a1_node_type *node_data;
    struct x1f4_dxcast_type *object_text;
    unsigned class, post_type;
    void **rail, *slip;

    node_data = instant_data->fail_node;

    link_data = node_data->link_data;

    post_data += lock;

    class = node_data->linetext.function.count;

    object_text = instant_data->s.lead;
    object_text -= class;

    rail = (void *) (object_text + link);
    rail -= class;

    link_args += call;

    post_type = flags & X1f4_E4_POST_TYPE;

    if (call < class) {
	slip = used + (integral_q) link_data[call].datatext.link;
	if (post_type) {
	    if (link_args[link] & X1f4_E4_POST_XSET) {
		slip = *(void **) slip;
	    }
	}
    } else {
	if (post_type) {
	    if (link_args[link] & X1f4_E4_POST_XSET) {
		slip = rail[call];
	    } else {
		if (*link_args == X1f4_E4_CASE) {
		    rail[call] = object_text + call;
		    slip = rail + call;
		} else {
		    slip = &object_text[call].data;
		}
	    }
	} else {
	    if (*link_args == X1f4_E4_CASE) {
		rail[call] = object_text + call;
		slip = rail + call;
	    } else {
		slip = &object_text[call].data;
	    }
	}
    }

    *post_data = slip;

    post_args += lock;

    *post_args = *link_args;

    if (scale) {
	post_args += 1 + line;

	if (post_type) {
	    *post_args = link_args[link];
	} else {
	    *post_args = 0;
	}
    }

    return 0;
}
