/*
 * a1-l.c.c
 * Copyright (C) 2011-2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <a1-types.h>
#include <e4.h>

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

static int beta_fine(void *, void *, void **);

const struct x1f4_function_type _x1f4_a1_l_c = {
/* *INDENT-OFF* */
    "count",
    beta_fine,
    X1f4_E4_MODE,
    NULL,
    0,
    X1f4_E4_KEEP_CALL,
    5
/* *INDENT-ON* */
};

static int
beta_fine(void *context, void *output, void **input)
{
    const struct x1f4_function_type *function_data;
    struct a1_instant_type *instant_data;

    instant_data = ((void **) input[-1])[X1f4_E4_USED_META];

    function_data = &instant_data->fail_node->linetext.function;
    if (function_data->flags & X1f4_E4_SIDE_LIST) {
	function_data = instant_data->s.function_data;
    }

    l_MODE(function_data->count, output);

    return 0;
}
