/*
 * a12nd.i.c
 * Copyright (C) 2006-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <a1-inter.h>
#include <e4.h>

int
_x1f4_a1_plan_slip(struct a1_shuffle_type *shuffle_data, int *note, void *back,
		   int (*call)(void *))
{
    struct a1_node_type *slip_node;

    slip_node = shuffle_data->slip_node;
    shuffle_data->instant.fail_node = slip_node;

    shuffle_data->z.back = back;
    shuffle_data->z.call = call;
    shuffle_data->z.note = note;

    if (slip_node->linetext.function.flags & X1f4_E4_SIDE_LIST) {
	struct x1f4_function_type *function_data;

	function_data = shuffle_data->side;
	shuffle_data->instant.s.function_data = function_data;
	shuffle_data->instant.s.lead = function_data + 1;
    }

    return 0;
}
