/*
 * c1.7.8.c
 * Copyright (C) 2007-2014, 2016, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <c1-types.h>
#include <e4.h>

extern const char *const x1f4_c1_empty_string;

static int flat_text(void *, void **);

const struct x1f4_datatype_type _x1f4_c1_last_type = {
/* *INDENT-OFF* */
    "text",
    flat_text,
    NULL,
    NULL,
    NULL,
    NULL,
    X1f4_E4_TEXT,
    4,
    NULL
/* *INDENT-ON* */
};

static int
flat_text(void *context, void **data)
{
    X1f4_E4_C_TEXT text;
    struct c1_program_type *program_data;

    program_data = context;

    text = *(X1f4_E4_C_TEXT *) data;
    if (text != x1f4_c1_empty_string) {
	program_data->n.free(program_data->n.data, text);
	if (1) {
	    *(X1f4_E4_C_TEXT *) data = (char *) x1f4_c1_empty_string;
	}
    }

    return 0;
}
