/*
 * e42nd.g.c
 * Copyright (C) 2006-2010, 2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4-defs.h>
#include <e4-types.h>

int
x1f4_pick_expression(struct e4_expression_type *expression_data,
		     const struct e4_ever_type **ever)
{
    int status = 1;
    struct e4_hack_type *hack_data;

    hack_data = &expression_data->hack;
    while (hack_data->count == 1) {
	int type;
	struct e4_atom_type *atom_data;

	atom_data = hack_data->atoms;
	type = atom_data->type;
	if (type == THIS) {
	    hack_data = atom_data->data.hack.data;
	} else {
	    if (type == EVER) {
		*ever = atom_data->data.ever.ever_data;
		status = 0;
	    }

	    break;
	}
    }

    return status;
}
