/*
 * lxdash-i.j.c
 * Copyright (C) 2011-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <lxcall.h>
#include <lxcast.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define dxdash(list) \
    ((struct dxdash_type *) (list))
#define lxdash(list) \
    ((struct lxdash_type *) (list))

extern const void *const x1f4_a1_walk_link;

static int rule_dash(void *, void *);

static int
rule_dash(void *line, void *data)
{
    struct fydata_type **fydata;

    fydata = line;

    l_MODE(((struct effect_type *) data)->mode, *fydata);

    (*fydata)++;

    return 0;
}


int
_libx1f4i0_lxdash_very_list(void *lxdash, void *output, void **input,
			    void **track,
			    struct x1f4_linetext_type *linetext_data,
			    unsigned count,
			    const struct x1f4_function_type *function_text,
			    int lead, int jack, void *dxdash)
{
    int status;
    void *beta;

    status = lxdash(lxdash)->link_v.link
	(lxdash(lxdash)->link_v.data, &beta,
	 count * sizeof(struct fydata_type));
    if (status) {
	status = _libx1f4i0_lxdash_stat_link(lxdash);
    } else {
	void *line;

	line = beta;
	status = _libx1f4i0_lime_lxfset
	    (dxdash(dxdash)->dash, &line, rule_dash);
	if (status) {
	} else {
	    if (output == x1f4_a1_walk_link) {
		status = _libx1f4i0_lxrail_draw_call
		    (lxdash, output, input, linetext_data, count,
		     function_text, lead, jack, X1f4_E4_MODE, beta);
	    } else {
		status = _libx1f4i0_lxrail_jack_call
		    (lxdash, output, input, linetext_data, count,
		     function_text, lead, jack, X1f4_E4_MODE, beta);
	    }
	}
    }

    return status;
}
