/*
 * lxdash-k.f.c
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <copy.h>
#include <d_fset.h>
#include <e4.h>
#include <fd.h>
#include <lxcall.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_f_keeping(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxdash_type *dxdash_data;
    struct lxdash_type *lxdash_data;
    void *data;

    dxdash_data = I_LINE(input[1]);

    cxbend_data = context;

    status = cxbend_data->pick(dxdash_data->dash, &data);
    if (status) {
	l_MODE(0, output);
	if (1) {
	    status = 0;
	}
    } else {
	struct effect_type *effect_data;
	unsigned call, type;

	lxdash_data = cxbend_data->line;

	effect_data = data;

	type = effect_data->type;
	call = *((struct x1f4_function_type *)
		 ((void **) input[-1])[X1f4_E4_RENDITION])->args;
	if (type != call) {
	    status = _libx1f4i0_lxdash_stat_type
		(lxdash_data, effect_data->mode, type, call);
	} else {
	    l_MODE(effect_data->mode, input[2]);
	    if (0) {
	    } else {
		unsigned link;

		link = effect_data->link;

		l_MODE(1, output);

		do {
		    if (~link) {
			struct lxtext_type *lxtext_data;

			lxtext_data = lxdash_data->link_f.text;
			lxtext_data += link;
			if (lxtext_data->lxtype.lead
			    && lxtext_data->lxtype.slip) {
			    status = _libx1f4i0_lxcall_land_node
				(&lxdash_data->link_v, &lxdash_data->link_e,
				 &lxtext_data->lxtype,
				 I_USER(&effect_data->fxdata), input[0]);
			    if (1) {
				break;
			    }
			}

			if (lxtext_data->lxtype.copy
			    && lxtext_data->lxtype.push) {
			    status = _libx1f4i0_lxcall_side_node
				(&lxtext_data->lxtype,
				 I_USER(&effect_data->fxdata), input[0]);
			    if (1) {
				break;
			    }
			}
		    }

		    copy_miss(*input, type, &effect_data->fxdata);
		} while (0);
	    }
	}
    }

    return status;
}
