/*
 * lxdash-l.v.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <fd.h>
#include <lxcall.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_USER(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_v_logique(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    void *data;

    dxdash_data = I_LINE(input[0]);

    effect.mode = I_MODE(input[1]);

#if 0
    status = x1f4_find_lxfset(dxdash_data->dash, &effect, &data);
    if (status) {
	struct effect_type *effect_data;
	struct lxtext_type *lxtext_data;
	unsigned type;

	status = 0;

	effect_data = data;

	lxtext_data = context;

	type = effect_data->type;
	if (type != lxtext_data->lxtype.code) {
	    status = _libx1f4i0_lxdash_stat_type
		(lxtext_data->text, effect.mode, type,
		 lxtext_data->lxtype.code);
	} else {
	    struct lxdash_type *lxdash_data;

	    lxdash_data = lxtext_data->text;

	    if (lxtext_data->lxtype.lead) {
		status = x1f4_auto_node
		    (&lxdash_data->link_v, &lxdash_data->link_e,
		     &lxtext_data->lxtype, &effect_data->fxdata, output);
	    } else {
		l_USER(I_USER(&effect_data->fxdata), output);
	    }
	}
    } else {
	status = _libx1f4i0_lxdash_n_logique(context, output, input);
    }
#else
    do {
	struct lxdash_type *lxdash_data;
	struct lxtext_type *lxtext_data;

	lxtext_data = context;

	dxdash_data = I_LINE(input[0]);

	lxdash_data = lxtext_data->text;

	status = x1f4_post_lxfset(dxdash_data->dash, &effect, &data);
	if (status) {
	    if (status == X1f4_BQFSET_EVER_MATCH) {
		struct effect_type *effect_data;
		unsigned type;

		effect_data = data;

		status = 0;

		type = effect_data->type;
		if (type != lxtext_data->lxtype.code) {
		    status = _libx1f4i0_lxdash_stat_type
			(lxtext_data->text, effect.mode, type,
			 lxtext_data->lxtype.code);
		} else {
		    if (lxtext_data->lxtype.lead) {
			status = x1f4_auto_node
			    (&lxdash_data->link_v, &lxdash_data->link_e,
			     &lxtext_data->lxtype, &effect_data->fxdata,
			     output);
		    } else {
			l_USER(I_USER(&effect_data->fxdata), output);
		    }
		}
	    } else {
		status =
		    _libx1f4i0_lxdash_stat_line(lxtext_data->text, 0, status);
	    }
	} else {
	    struct effect_type *effect_data;
	    unsigned link, type;
	    void *post;

	    effect_data = data;

	    effect_data->mode = effect.mode;

	    type = lxtext_data->lxtype.code;

	    effect_data->type = type;

	    status = lxtext_data->lxtype.post
		(lxtext_data->lxtype.context, &post,
		 lock_excase(dxdash_data));
	    if (status) {
		effect_data->link = ~0;

		_libx1f4i0_cast_lxfset(dxdash_data->dash, &effect);

		break;
	    } else {
		l_USER(post, &effect_data->fxdata);

		dxdash_data->size++;

		link = lxtext_data
		    - ((struct lxtext_type *) lxdash_data->link_f.text);

		if (lxtext_data->lxtype.lead) {
		    status = x1f4_auto_node
			(&lxdash_data->link_v, &lxdash_data->link_e,
			 &lxtext_data->lxtype, &post, output);
		} else {
		    l_USER(post, output);
		}
	    }

	    effect_data->link = link;
	}
    } while (0);
#endif				/* 0 */

    return status;
}
