/*
 * lxdash-m.a.n.c
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <fd.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_a_break_m(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    void *data;

    dxdash_data = I_LINE(input[0]);

    cxbend_data = context;

    do {
	X1f4_E4_C_MODE mode;
	struct effect_type *effect_data;

	mode = I_MODE(input[2]);
	mode *= cxbend_data->sign;

	effect.mode = I_MODE(input[1]);

	status = x1f4_post_lxfset(dxdash_data->dash, &effect, &data);
	if (status) {
	    if (status ^ X1f4_BQFSET_EVER_MATCH) {
		status = _libx1f4i0_lxdash_stat_line
		    (cxbend_data->line, 0, status);

		break;
	    } else {
		unsigned type;

		effect_data = data;

		type = effect_data->type;
		if (type != X1f4_E4_MODE) {
		    status = _libx1f4i0_lxdash_stat_type
			(cxbend_data->line, effect.mode, type, X1f4_E4_MODE);
		    if (1) {
			break;
		    }
		}

		status = 0;

		mode += I_MODE(&effect_data->fxdata);
	    }
	} else {
	    effect_data = data;

	    dxdash_data->size++;

	    effect_data->mode = effect.mode;

	    effect_data->type = X1f4_E4_MODE;
	    effect_data->link = ~0;
	}

	{
	    l_MODE(mode, output);

	    l_MODE(mode, &effect_data->fxdata);
	}
    } while (0);

    return status;
}
