/*
 * lxdash-m.g-c.c
 * Copyright (C) 2008-2015, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <e4.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_BILL(t)			(*((X1f4_E4_C_BILL *) (t)))
#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_REAL(t)			(*((X1f4_E4_C_REAL *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_g_press_m(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    dxdash_data = I_LINE(input[1]);

    effect.mode = I_MODE(input[2]);

    status = x1f4_find_lxfset(dxdash_data->dash, &effect, &data);
    if (status) {
	X1f4_E4_C_MODE mode;
	struct effect_type *effect_data;
	unsigned type;

	status = 0;

	effect_data = data;

	type = effect_data->type;
	switch (type) {
	case X1f4_E4_BILL:
	    mode = I_BILL(&effect_data->fxdata);
	    break;
	case X1f4_E4_MODE:
	    mode = I_MODE(&effect_data->fxdata);
	    break;
	case X1f4_E4_REAL:
	    mode = I_REAL(&effect_data->fxdata);
	    break;
	default:
	    mode = 0;
	    status = _libx1f4i0_lxdash_stat_type
		(lxtext_data->text, effect.mode, type, X1f4_E4_MODE);
	}

	if (status) {
	} else {
	    l_MODE(mode, input[0]);
	    l_MODE(mode, output);
	}
    } else {
	status = _libx1f4i0_lxdash_stat_miss(lxtext_data->text, effect.mode);
    }

    return status;
}
