/*
 * lxdash-t.o.c
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdash-config.h>

#include <d_fset.h>
#include <e4.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define l_TEXT(e, output) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

extern const struct x1f4_bqnorm_type _libx1f4i0_lxdash_u_norm,
    _libx1f4i0_lxdash_w_norm;

int
_libx1f4i0_lxdash_o_class_t(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    struct lxtext_type *lxtext_data;
    void *dash;
#if __CLIP_EXTRACT__
#else
    void *data;
#endif				/* __CLIP_EXTRACT__ */

    lxtext_data = context;

    lxdash_data = lxtext_data->text;

    dxdash_data = I_LINE(input[1]);

    dash = dxdash_data->dash;

    effect.mode = I_MODE(input[2]);
    effect.type = X1f4_E4_TEXT;

#if __CLIP_EXTRACT__
    _libx1f4i0_norm_lxfset(dash, &_libx1f4i0_lxdash_w_norm);
    status = _libx1f4i0_cast_lxfset(dash, &effect);
    _libx1f4i0_norm_lxfset(dash, &_libx1f4i0_lxdash_u_norm);
    if (status) {
	if (status == X1f4_BQFSET_MISS_CLASS) {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	} else {
	    status = _libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
	}
    } else {
	dxdash_data->size--;

	status = lxtext_data->lxtype.push
	    (lxtext_data->lxtype.context, input[0], I_TEXT(&effect.fxdata),
	     lock_excase(dxdash_data));
	if (status) {
	} else {
	    l_MODE(1, output);
	}
    }
#else
    status = x1f4_find_lxfset(dash, &effect, &data);
    if (status) {
	struct effect_type *effect_data;
	unsigned type;

	effect_data = data;

	type = effect_data->type;
	if (type != X1f4_E4_TEXT) {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	} else {
	    status = lxtext_data->lxtype.push
		(lxtext_data->lxtype.context, input[0],
		 I_TEXT(&effect_data->fxdata), lock_excase(dxdash_data));
	    if (status) {
	    } else {
		effect_data->link = ~0;

		status = _libx1f4i0_cast_lxfset(dash, &effect);
		if (status) {
		    status =
			_libx1f4i0_lxdash_stat_line(lxdash_data, 0, status);
		} else {
		    dxdash_data->size--;

		    if (1) {
			l_MODE(1, output);
		    }
		}
	    }
	}
    } else {
	l_MODE(0, output);
    }
#endif				/* __CLIP_EXTRACT__ */

    return status;
}
