/*
 * lxdash-t.p.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <d_fset.h>
#include <e4.h>
#include <fd.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_TEXT(e, output) \
    {									      \
	X1f4_E4_C_TEXT *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdash_p_class_t(void *context, void *output, void **input)
{
    int status;
    struct dxdash_type *dxdash_data;
    struct effect_type effect;
    struct lxdash_type *lxdash_data;
    struct lxtext_type *lxtext_data;
    void *data, *slip;

    lxtext_data = context;

    dxdash_data = I_LINE(input[0]);

    lxdash_data = lxtext_data->text;

    status = lxtext_data->lxtype.copy
	(lxtext_data->lxtype.context, NULL, &slip,
	 I_TEXT(input[2]), lock_excase(dxdash_data));
    if (status) {
    } else {
	if (0) {
	} else {
	    effect.mode = I_MODE(input[1]);

	    status = x1f4_post_lxfset(dxdash_data->dash, &effect, &data);
	    if (status) {
		status = _libx1f4i0_lxdash_stat_text
		    (lxtext_data->text, status, effect.mode);

		lxtext_data->lxtype.free
		    (lxtext_data->lxtype.context, slip, NULL,
		     lock_excase(dxdash_data));
	    } else {
		struct effect_type *effect_data;
		unsigned link;

		effect_data = data;

		effect_data->type = X1f4_E4_TEXT;

		effect_data->mode = effect.mode;

		link = lxtext_data
		    - ((struct lxtext_type *) lxdash_data->link_f.text);

		effect_data->link = link;

		dxdash_data->size++;

		l_TEXT(slip, &effect_data->fxdata);
	    }
	}
    }

    return status;
}
