/*
 * lxdata-c.z.f.c
 * Copyright (C) 2013-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <ctype.0.h>
#include <e4.h>
#include <lxdata-inter.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

static void fail_data(unsigned char *, unsigned *, unsigned *);

static void
fail_data(unsigned char *data, unsigned *fail, unsigned *side)
{
    unsigned size, slip;
    unsigned char *text;

    side[0] &= ~1;

    text = data;

    size = *fail;

    slip = size;
    for (; slip; slip--) {
	int c;

	c = *data;
	if (C_TYPE_X(side, c)) {
	    break;
	} else {
	    data++;
	}
    }

    if (slip ^ size) {
	memmove(text, data, slip + 1);

	*fail = slip;
    }
}


int
_libx1f4i0_lxdata_zfcentric(void *context, void *output, void **input)
{
    return _libx1f4i0_lxdata_drop_line
	(context, I_DATA(input[0]), I_TEXT(input[1]), fail_data);
}
