/*
 * lxdata-e.1.c
 * Copyright (C) 2008-2011, 2013, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <lxdata-inter.h>
#include <lxdata-size.h>
#include <lxdata-types.h>

extern const char *const x1f4_c1_empty_string;

int
_libx1f4i0_lxdata_clip_long(void *lxdata, void *dxdata, unsigned head,
			    unsigned tail)
{
    int status;

    do {
	struct dxdata_type *dxdata_data;
	unsigned rate, size;

	dxdata_data = dxdata;

	size = dxdata_data->length;

	if (tail < head) {
	    rate = head - 1 - tail;
	} else {
	    rate = size + head - 1 - tail;
	}

	if (rate) {
	    unsigned copy;
	    void *text;

	    text = dxdata_data->string;

	    if (tail < head) {
		memmove(text, (char *) text + tail + 1, rate);
	    } else {
		memmove((char *) text + head, (char *) text + tail + 1,
			size - 1 - tail);
	    }

	    if (rate < 16) {
		copy = 16;
	    } else {
		text_size(copy, rate);
	    }

	    if (1) {
		struct lxdata_type *lxdata_data;

		lxdata_data = lxdata;

		status = lxdata_data->link_m.mode
		    (lxdata_data->link_m.data, &text, copy + 1);
		if (status) {
		    status = _libx1f4i0_lxdata_stat_mode(lxdata_data);
		} else {
		    char *slip;

		    slip = text;
		    slip[rate] = 0;

		    dxdata_data->length = rate;
		    dxdata_data->string = text;
		}
	    }
	} else {
	    if (1) {
		struct lxdata_type *lxdata_data;

		lxdata_data = lxdata;

		status = lxdata_data->link_m.free
		    (lxdata_data->link_m.data, dxdata_data->string);
		if (status) {
		    status = _libx1f4i0_lxdata_stat_free(lxdata_data, 0);
		} else {
		    dxdata_data->length = 0;
		    dxdata_data->string = (char *) x1f4_c1_empty_string;
		}
	    }
	}
    } while (0);

    return status;
}
