/*
 * lxdata-e.2.c
 * Copyright (C) 2008, 2009, 2010, 2011, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <lxdata-inter.h>
#include <lxdata-size.h>
#include <lxdata-types.h>

int
x1f4_rule_lxdata(void *lxdata, void *dxdata, unsigned rule, unsigned mode,
		 void *bill)
{
    int status;

    do {
	struct dxdata_type *dxdata_data;
	unsigned size;
	void *text;

	dxdata_data = dxdata;

	size = dxdata_data->length;

	text = dxdata_data->string;

	if ((char *) bill < (char *) text
	    || (char *) text + size < (char *) bill) {
	    status = _libx1f4i0_lxdata_rule_text
		(lxdata, dxdata_data, rule, mode, bill);
	} else {
	    unsigned fail;

	    fail = rule + mode;

	    if (size < fail) {
		unsigned call, copy;

		if (fail < 16) {
		    copy = 16;
		} else {
		    text_size(copy, fail);
		}

		if (size < 16) {
		    call = 16;
		} else {
		    text_size(call, size);
		}
		if (copy ^ call) {
		    int offset;
		    struct lxdata_type *lxdata_data;

		    lxdata_data = lxdata;

		    offset = (char *) bill - (char *) text;

		    status = lxdata_data->link_m.mode
			(lxdata_data->link_m.data, &text, copy + 1);
		    if (status) {
			status = _libx1f4i0_lxdata_stat_mode(lxdata_data);
			if (1) {
			    break;
			}
		    }

		    bill = (char *) text + offset;
		} else {
		    status = 0;
		}

		dxdata_data->length = fail;
		dxdata_data->string = text;

		if (1) {
		    char *dana;

		    dana = text;
		    dana += fail;
		    *dana = 0;
		}
	    } else {
		status = 0;
	    }

	    memmove((char *) text + rule, bill, mode);
	}
    } while (0);

    return status;
}
