/*
 * lxdata-l.c.c
 * Copyright (C) 2008-2010, 2013, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxdata-config.h>

#include <string.h>

#include <e4.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))

extern const char *const x1f4_c1_empty_string;

int
_libx1f4i0_lxdata_c_logique(void *context, void *output, void **input)
{
    int status;
    struct dxdata_type *dxdata_data;

    dxdata_data = I_DATA(input[0]);

    if (dxdata_data->length) {
	struct lxdata_type *lxdata_data;

	lxdata_data = context;

	status = lxdata_data->link_m.free
	    (lxdata_data->link_m.data, dxdata_data->string);
	if (status) {
	    status = _libx1f4i0_lxdata_stat_free(lxdata_data, 0);
	} else {
	    dxdata_data->length = 0;
	    dxdata_data->string = (char *) x1f4_c1_empty_string;
	}
    } else {
	status = 0;
    }

    return status;
}
