/*
 * lxdecq-inter.h
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxdecq_inter_H__
#define __LIBx1f4_lxdecq_inter_H__

#include <lxdecq-config.h>

#include <cl.h>
#include <dt.h>
#include <e4.h>
#include <lxdecq-types.h>
#include <lxplus.h>
#include <lxnorm.h>
#include <lxwide.h>
#include <nt.h>
#include <trans.h>

#define _libx1f4i0_lxdecq_bset_list	x1f4_bset_lxdecq
#define _libx1f4i0_lxdecq_cfix_list	x1f4_cfix_lxdecq
#define _libx1f4i0_lxdecq_call_list	x1f4_call_lxdecq
#define _libx1f4i0_lxdecq_clip_list	x1f4_clip_lxdecq
#define _libx1f4i0_lxdecq_copy_list	x1f4_copy_lxdecq
#define _libx1f4i0_lxdecq_deck_list	x1f4_deck_lxdecq
#define _libx1f4i0_lxdecq_dset_list	x1f4_dset_lxdecq
#define _libx1f4i0_lxdecq_dump_list	x1f4_dump_lxdecq
#define _libx1f4i0_lxdecq_fini_list	x1f4_fini_lxdecq
#define _libx1f4i0_lxdecq_flat_list	x1f4_flat_lxdecq
#define _libx1f4i0_lxdecq_free_list	x1f4_free_lxdecq
#define _libx1f4i0_lxdecq_fset_list	x1f4_fset_lxdecq
#define _libx1f4i0_lxdecq_hash_list	x1f4_hash_lxdecq
#define _libx1f4i0_lxdecq_init_list	x1f4_init_lxdecq
#define _libx1f4i0_lxdecq_lead_list	x1f4_lead_lxdecq
#define _libx1f4i0_lxdecq_line_list	x1f4_line_lxdecq
#define _libx1f4i0_lxdecq_link_list	x1f4_link_lxdecq
#define _libx1f4i0_lxdecq_miss_list	x1f4_miss_lxdecq
#define _libx1f4i0_lxdecq_near_list	x1f4_near_lxdecq
#define _libx1f4i0_lxdecq_node_list	x1f4_node_lxdecq
#define _libx1f4i0_lxdecq_post_list	x1f4_post_lxdecq
#define _libx1f4i0_lxdecq_pull_list	x1f4_pull_lxdecq
#define _libx1f4i0_lxdecq_seek_list	x1f4_seek_lxdecq
#define _libx1f4i0_lxdecq_slip_list	x1f4_slip_lxdecq
#define _libx1f4i0_lxdecq_tile_list	x1f4_tile_lxdecq
#define _libx1f4i0_lxdecq_type_list	x1f4_type_lxdecq

#define __types_long(lxdecq) \
    (&((struct lxdecq_type *) (lxdecq))->ever_r.over_1.rule_1.nice_1)

#define _libx1f4i0_lxdecq_stat_free(___l, ___1) \
    _libx1f4i0_lxlock_stat_free(__types_long((___l)), (___1))
#define _libx1f4i0_lxdecq_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_long((___l)))
#define _libx1f4i0_lxdecq_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_long((___l)))

#define _libx1f4i0_lxdecq_s_forward	_libx1f4i0_lxnorm_s_forward

extern int _libx1f4i0_lxdecq_a_keeping(void *, void *, void **);
extern int _libx1f4i0_lxdecq_bset_list
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxdecq_c_forward(void *, void *, void **);
extern int _libx1f4i0_lxdecq_c_logique(void *, void *, void **);
extern int _libx1f4i0_lxdecq_c_nearest(void *, void *, void **);
extern int _libx1f4i0_lxdecq_c_pending(void *, void *, void **);
extern int _libx1f4i0_lxdecq_call_list(void *, struct excase_type *);
extern int _libx1f4i0_lxdecq_cfix_list(void *, unsigned, void *);
extern int _libx1f4i0_lxdecq_clip_list
    (unsigned, const void *, struct x1f4_nodetype_type **, int *);
extern int _libx1f4i0_lxdecq_copy_link(void *, void *, const void *);
extern int _libx1f4i0_lxdecq_copy_list
    (void *, void *, void **, const void *, const struct excase_type *);
extern int _libx1f4i0_lxdecq_copy_text
    (void *, void *, void **, const void *, const struct excase_type *);
extern int _libx1f4i0_lxdecq_down_list(void *, void *, void *);
extern int _libx1f4i0_lxdecq_dset_list
    (void *, const struct x1f4_datatype_type **);
extern int _libx1f4i0_lxdecq_dump_list(void *, struct excase_type *);
extern int _libx1f4i0_lxdecq_e0class_b(void *, void *, void **);
extern int _libx1f4i0_lxdecq_e0class_m(void *, void *, void **);
extern int _libx1f4i0_lxdecq_e0class_r(void *, void *, void **);
extern int _libx1f4i0_lxdecq_e0class_t(void *, void *, void **);
extern int _libx1f4i0_lxdecq_ebclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_ebclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_efclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_efclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_f_forward(void *, void *, void **);
extern int _libx1f4i0_lxdecq_f_keeping(void *, void *, void **);
extern int _libx1f4i0_lxdecq_fast_list(void *, void *);
extern int _libx1f4i0_lxdecq_fine_list(void *, void *);
extern int _libx1f4i0_lxdecq_fini_list(void **);
extern int _libx1f4i0_lxdecq_flat_list(void *, void **);
extern int _libx1f4i0_lxdecq_free_link(void *, void *);
extern int _libx1f4i0_lxdecq_free_list
    (void *, void *, struct excase_type **, const struct excase_type *);
extern int _libx1f4i0_lxdecq_free_text
    (void *, void *, struct excase_type **, const struct excase_type *);
extern int _libx1f4i0_lxdecq_fset_list
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxdecq_g0class_b(void *, void *, void **);
extern int _libx1f4i0_lxdecq_g0class_m(void *, void *, void **);
extern int _libx1f4i0_lxdecq_g0class_r(void *, void *, void **);
extern int _libx1f4i0_lxdecq_g0class_t(void *, void *, void **);
extern int _libx1f4i0_lxdecq_g0classsb(void *, void *, void **);
extern int _libx1f4i0_lxdecq_g0classsm(void *, void *, void **);
extern int _libx1f4i0_lxdecq_g0classsr(void *, void *, void **);
extern int _libx1f4i0_lxdecq_g0classst(void *, void *, void **);
extern int _libx1f4i0_lxdecq_gbclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_gbclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_gbclasssu(void *, void *, void **);
extern int _libx1f4i0_lxdecq_gbclasssv(void *, void *, void **);
extern int _libx1f4i0_lxdecq_gfclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_gfclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_gfclasssu(void *, void *, void **);
extern int _libx1f4i0_lxdecq_gfclasssv(void *, void *, void **);
extern int _libx1f4i0_lxdecq_hash_list
    (void *, struct excase_type **, struct excase_type *);
extern int _libx1f4i0_lxdecq_heap_list(void *, struct excase_type **, void *);
extern int _libx1f4i0_lxdecq_init_list
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxdecq_j0class_b(void *, void *, void **);
extern int _libx1f4i0_lxdecq_j0class_m(void *, void *, void **);
extern int _libx1f4i0_lxdecq_j0class_r(void *, void *, void **);
extern int _libx1f4i0_lxdecq_j0class_t(void *, void *, void **);
extern int _libx1f4i0_lxdecq_j0classsb(void *, void *, void **);
extern int _libx1f4i0_lxdecq_j0classsm(void *, void *, void **);
extern int _libx1f4i0_lxdecq_j0classsr(void *, void *, void **);
extern int _libx1f4i0_lxdecq_j0classst(void *, void *, void **);
extern int _libx1f4i0_lxdecq_jbclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_jbclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_jbclasssu(void *, void *, void **);
extern int _libx1f4i0_lxdecq_jbclasssv(void *, void *, void **);
extern int _libx1f4i0_lxdecq_jfclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_jfclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_jfclasssu(void *, void *, void **);
extern int _libx1f4i0_lxdecq_jfclasssv(void *, void *, void **);
extern int _libx1f4i0_lxdecq_l_logique(void *, void *, void **);
extern int _libx1f4i0_lxdecq_late_list
    (void *, void *, void *, const void *);
extern int _libx1f4i0_lxdecq_lead_list(void *, void **);
extern int _libx1f4i0_lxdecq_line_list(void *, void **);
extern int _libx1f4i0_lxdecq_link_link(void *, void *, const void *);
extern int _libx1f4i0_lxdecq_link_list(void *, void **);
extern int _libx1f4i0_lxdecq_n_forward(void *, void *, void **);
extern int _libx1f4i0_lxdecq_near_list(void *);
extern int _libx1f4i0_lxdecq_node_list
    (void *, void **, void *, const struct excase_type *);
extern int _libx1f4i0_lxdecq_null_list
    (void *, struct excase_type **, void *);
extern int _libx1f4i0_lxdecq_o0class_b(void *, void *, void **);
extern int _libx1f4i0_lxdecq_o0class_m(void *, void *, void **);
extern int _libx1f4i0_lxdecq_o0class_r(void *, void *, void **);
extern int _libx1f4i0_lxdecq_o0class_t(void *, void *, void **);
extern int _libx1f4i0_lxdecq_obclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_obclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_ofclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_ofclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_p0class_b(void *, void *, void **);
extern int _libx1f4i0_lxdecq_p0class_m(void *, void *, void **);
extern int _libx1f4i0_lxdecq_p0class_r(void *, void *, void **);
extern int _libx1f4i0_lxdecq_pbclass_t(void *, void *, void **);
extern int _libx1f4i0_lxdecq_pbclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_pbclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_pfclass_t(void *, void *, void **);
extern int _libx1f4i0_lxdecq_pfclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_pfclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_post_list
    (void *, void **, const struct excase_type *);
extern int _libx1f4i0_lxdecq_pull_list
    (void *, void *, void *, const void *, struct trans_type *,
     struct x1f4_caselink_type **);
extern int _libx1f4i0_lxdecq_push_text
    (void *, void **, void *, const struct excase_type *);
extern int _libx1f4i0_lxdecq_q0class_b(void *, void *, void **);
extern int _libx1f4i0_lxdecq_q0class_m(void *, void *, void **);
extern int _libx1f4i0_lxdecq_q0class_r(void *, void *, void **);
extern int _libx1f4i0_lxdecq_q0class_t(void *, void *, void **);
extern int _libx1f4i0_lxdecq_q0classsb(void *, void *, void **);
extern int _libx1f4i0_lxdecq_q0classsm(void *, void *, void **);
extern int _libx1f4i0_lxdecq_q0classsr(void *, void *, void **);
extern int _libx1f4i0_lxdecq_q0classst(void *, void *, void **);
extern int _libx1f4i0_lxdecq_qbclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_qbclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_qbclasssu(void *, void *, void **);
extern int _libx1f4i0_lxdecq_qbclasssv(void *, void *, void **);
extern int _libx1f4i0_lxdecq_qfclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_qfclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_qfclasssu(void *, void *, void **);
extern int _libx1f4i0_lxdecq_qfclasssv(void *, void *, void **);
extern int _libx1f4i0_lxdecq_s_logique(void *, void *, void **);
extern int _libx1f4i0_lxdecq_seek_list(const void *);
extern int _libx1f4i0_lxdecq_side_list(void *, void *);
extern int _libx1f4i0_lxdecq_slip_list(void *, void **);
extern int _libx1f4i0_lxdecq_spin_list(void *, void *, void *);
extern int _libx1f4i0_lxdecq_stat_call(void *, int, unsigned, unsigned, int);
extern int _libx1f4i0_lxdecq_stat_copy(void *);
extern int _libx1f4i0_lxdecq_stat_ends(void *, int, unsigned, unsigned);
extern int _libx1f4i0_lxdecq_stat_list(void *, int, int);
extern int _libx1f4i0_lxdecq_stat_null(void *);
extern int _libx1f4i0_lxdecq_stat_size(void *);
extern int _libx1f4i0_lxdecq_stat_type(void *, int, unsigned, unsigned);
extern int _libx1f4i0_lxdecq_swap_list(void *, void *);
extern int _libx1f4i0_lxdecq_tile_list
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxdecq_type_list(struct x1f4_nodetype_type *, int);
extern int _libx1f4i0_lxdecq_u_forward(void *, void *, void **);
extern int _libx1f4i0_lxdecq_x0class_b(void *, void *, void **);
extern int _libx1f4i0_lxdecq_x0class_m(void *, void *, void **);
extern int _libx1f4i0_lxdecq_x0class_r(void *, void *, void **);
extern int _libx1f4i0_lxdecq_x0class_t(void *, void *, void **);
extern int _libx1f4i0_lxdecq_xbclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_xbclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_xfclass_u(void *, void *, void **);
extern int _libx1f4i0_lxdecq_xfclass_v(void *, void *, void **);
extern int _libx1f4i0_lxdecq_z_forward(void *, void *, void **);

#endif				/* __LIBx1f4_lxdecq_inter_H__ */
