/*
 * lxdecq-v.j.f.c
 * Copyright (C) 2008-2010, 2013, 2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <f_list.h>
#include <lxcall.h>
#include <lxdecq-drive.h>
#include <lxdecq-inter.h>
#include <lxdecq-types.h>

#define I_LIST(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxdecq_jfclass_v(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data;
    struct lxdecq_type *lxdecq_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    lxdecq_data = lxtext_data->text;

    dxlist_data = I_LIST(input[1]);

    status = _libx1f4i0_lead_dllist(dxlist_data->list, &data);
    if (status) {
	if (status == X1f4_DLLIST_DECK_ERROR) {
	    l_MODE(0, output);
	    if (1) {
		status = 0;
	    }
	} else {
	    status = _libx1f4i0_lxdecq_stat_list(lxdecq_data, 0, status);
	}
    } else {
	unsigned type;

	type = effect_type(data);
	if (type != lxtext_data->lxtype.code) {
	    l_MODE(0, output);
	} else {
	    status = _libx1f4i0_lxcall_land_node
		(&lxdecq_data->link_v, &lxdecq_data->link_e,
		 &lxtext_data->lxtype, I_USER(byte(data) + 8),
		 input[0]);
	    if (status) {
	    } else {
		l_MODE(1, output);
	    }
	}
    }

    return status;
}
