/*
 * lxfile-e.k.c
 * Copyright (C) 2010, 2011, 2013-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxfile-defs.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>
#include <lxwide.h>

int
x1f4_tile_lxfile(void **lxfile, unsigned bits,
		 struct x1f4_lxwide_type *lxwide_data, unsigned tile,
		 const void *data)
{
    int status, type;
    struct screen_type screen;
    unsigned flags;

    if (data) {
	screen = *(const struct screen_type *) data;
    }

    flags = tile;

    if (1) {
	lxwide_data->widetype_set.type++;
	screen.link_l.type = lxwide_data->widetype_set.type;
    }

    if (x1f4_mind_lxwide(&type, lxwide_data, "data", 4)) {
	flags |= DATALINK_LINK;
	screen.link_f.type = type;
    }

    if (x1f4_mind_lxwide(&type, lxwide_data, "list", 4)) {
	flags |= LISTLINK_LINK;
	screen.link_i.type = type;
    }

    if (bits & X1f4_LXWIDE_CODELINK) {
	if (flags & CODELINK_LINK) {
	} else {
	    flags |= CODELINK_LINK;
	    screen.lock_w = lxwide_data->codelink_set;
	}
    }

    if (1) {
	if (flags & AUTOLINK_LINK) {
	} else {
	    flags |= AUTOLINK_LINK;
	    screen.lock_v = lxwide_data->autolink_set;
	}
    }

    if (bits & X1f4_LXWIDE_RESOURCE) {
	if (flags & RESOURCE_LINK) {
	} else {
	    flags |= RESOURCE_LINK;
	    screen.lock_m = lxwide_data->resource_set;
	}
    }

    if (bits & X1f4_LXWIDE_TEXTFLAT) {
	if (flags & TEXTFLAT_LINK) {
	} else {
	    flags |= TEXTFLAT_LINK;
	    screen.lock_e = lxwide_data->textflat_set;
	}
    }

    status = _libx1f4i0_lxfile_init_file(lxfile, flags, &screen);
    if (status) {
    } else {
    }

    return status;
}
