/*
 * lxfile-inter.h
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxfile_inter_H__
#define __LIBx1f4_lxfile_inter_H__

#include <dt.h>
#include <e4.h>
#include <ix.h>
#include <lxfile-types.h>
#include <lxmode.h>
#include <lxwide.h>
#include <nt.h>

#define _libx1f4i0_dxfile_lose_file	x1f4_lose_dxfile
#define _libx1f4i0_dxfile_pick_file	x1f4_pick_dxfile
#define _libx1f4i0_dxfile_posh_file	x1f4_posh_dxfile

#define _libx1f4i0_lxfile_bset_file	x1f4_bset_lxfile
#define _libx1f4i0_lxfile_clip_file	x1f4_clip_lxfile
#define _libx1f4i0_lxfile_copy_file	x1f4_copy_lxfile
#define _libx1f4i0_lxfile_dset_file	x1f4_dset_lxfile
#define _libx1f4i0_lxfile_fini_file	x1f4_fini_lxfile
#define _libx1f4i0_lxfile_flat_file	x1f4_flat_lxfile
#define _libx1f4i0_lxfile_free_file	x1f4_free_lxfile
#define _libx1f4i0_lxfile_fset_file	x1f4_fset_lxfile
#define _libx1f4i0_lxfile_init_file	x1f4_init_lxfile
#define _libx1f4i0_lxfile_lead_file	x1f4_lead_lxfile
#define _libx1f4i0_lxfile_line_file	x1f4_line_lxfile
#define _libx1f4i0_lxfile_link_file	x1f4_link_lxfile
#define _libx1f4i0_lxfile_near_file	x1f4_near_lxfile
#define _libx1f4i0_lxfile_node_file	x1f4_node_lxfile
#define _libx1f4i0_lxfile_seek_file	x1f4_seek_lxfile
#define _libx1f4i0_lxfile_slip_file	x1f4_slip_lxfile
#define _libx1f4i0_lxfile_tile_file	x1f4_tile_lxfile
#define _libx1f4i0_lxfile_type_file	x1f4_type_lxfile
#define _libx1f4i0_lxfile_vset_file	x1f4_vset_lxfile
#define _libx1f4i0_lxfile_wrap_file	x1f4_wrap_lxfile

#define __types_long(lxfile) \
    (&((struct lxfile_type *) (lxfile))->ever_m.nice_1.east_1)

#define _libx1f4i0_lxfile_stat_free(___l, ___1) \
    _libx1f4i0_lxlock_stat_free(__types_long((___l)), (___1))
#define _libx1f4i0_lxfile_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_long((___l)))
#define _libx1f4i0_lxfile_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_long((___l)))

extern int _libx1f4i0_dxfile_lose_file
    (struct lxfile_type *, struct dxfile_type *);
extern int _libx1f4i0_lxfile_a_logique(void *, void *, void **);
extern int _libx1f4i0_lxfile_a_pending(void *, void *, void **);
extern int _libx1f4i0_lxfile_b_logique(void *, void *, void **);
extern int _libx1f4i0_lxfile_b_pending(void *, void *, void **);
extern int _libx1f4i0_lxfile_bset_file
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxfile_c_derived(void *, void *, void **);
extern int _libx1f4i0_lxfile_c_logique(void *, void *, void **);
extern int _libx1f4i0_lxfile_c_pending(void *, void *, void **);
extern int _libx1f4i0_lxfile_clip_file
    (unsigned, const void *, struct x1f4_nodetype_type **, int *);
extern int _libx1f4i0_lxfile_copy_file
    (void *, void *, void **, const void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxfile_d_centric(void *, void *, void **);
extern int _libx1f4i0_lxfile_d_logique(void *, void *, void **);
extern int _libx1f4i0_lxfile_dset_file
    (void *, const struct x1f4_datatype_type **);
extern int _libx1f4i0_lxfile_e_derived(void *, void *, void **);
extern int _libx1f4i0_lxfile_e_forward(void *, void *, void **);
extern int _libx1f4i0_lxfile_e_pending(void *, void *, void **);
extern int _libx1f4i0_lxfile_f_derived(void *, void *, void **);
extern int _libx1f4i0_lxfile_f_logique(void *, void *, void **);
extern int _libx1f4i0_lxfile_f_pending(void *, void *, void **);
extern int _libx1f4i0_lxfile_f_sequent(void *, void *, void **);
extern int _libx1f4i0_lxfile_fini_file(void **);
extern int _libx1f4i0_lxfile_flat_file(void *, void **);
extern int _libx1f4i0_lxfile_free_file
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxfile_fset_file
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxfile_h_pending(void *, void *, void **);
extern int _libx1f4i0_lxfile_i_forward(void *, void *, void **);
extern int _libx1f4i0_lxfile_init_file
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxfile_k_logique(void *, void *, void **);
extern int _libx1f4i0_lxfile_l_derived(void *, void *, void **);
extern int _libx1f4i0_lxfile_l_forward(void *, void *, void **);
extern int _libx1f4i0_lxfile_l_logique(void *, void *, void **);
extern int _libx1f4i0_lxfile_l_pending(void *, void *, void **);
extern int _libx1f4i0_lxfile_l_sequent(void *, void *, void **);
extern int _libx1f4i0_lxfile_land_line
    (void *, int, void *, unsigned, void *, void *);
extern int _libx1f4i0_lxfile_lead_file(void *, void **);
extern int _libx1f4i0_lxfile_line_file(void *, void **);
extern int _libx1f4i0_lxfile_link_file(void *, void **);
extern int _libx1f4i0_lxfile_m_derived(void *, void *, void **);
extern int _libx1f4i0_lxfile_miss_file(void *, void *);
extern int _libx1f4i0_lxfile_n_derived(void *, void *, void **);
extern int _libx1f4i0_lxfile_n_pending(void *, void *, void **);
extern int _libx1f4i0_lxfile_near_file(void *);
extern int _libx1f4i0_lxfile_node_file
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxfile_o_forward(void *, void *, void **);
extern int _libx1f4i0_lxfile_o_logique(void *, void *, void **);
extern int _libx1f4i0_lxfile_p_derived(void *, void *, void **);
extern int _libx1f4i0_lxfile_p_forward(void *, void *, void **);
extern int _libx1f4i0_lxfile_p_logique(void *, void *, void **);
extern int _libx1f4i0_lxfile_p_pending(void *, void *, void **);
extern int _libx1f4i0_dxfile_pick_file
    (struct lxfile_type *, struct dxfile_type *, int, unsigned);
extern int _libx1f4i0_dxfile_posh_file
    (struct lxfile_type *, struct dxfile_type *, int, unsigned);
extern int _libx1f4i0_lxfile_pull_file(void *, void *, unsigned, void **);
extern int _libx1f4i0_lxfile_puSh_file(void *, void *, unsigned, void **);
extern int _libx1f4i0_lxfile_r_pending(void *, void *, void **);
extern int _libx1f4i0_lxfile_s_centric(void *, void *, void **);
extern int _libx1f4i0_lxfile_s_derived(void *, void *, void **);
extern int _libx1f4i0_lxfile_s_forward(void *, void *, void **);
extern int _libx1f4i0_lxfile_s_logique(void *, void *, void **);
extern int _libx1f4i0_lxfile_s_nearest(void *, void *, void **);
extern int _libx1f4i0_lxfile_s_pending(void *, void *, void **);
extern int _libx1f4i0_lxfile_s_sequent(void *, void *, void **);
extern int _libx1f4i0_lxfile_seek_file(const void *);
extern int _libx1f4i0_lxfile_side_file(void *, void *);
extern int _libx1f4i0_lxfile_slip_file(void *, void **);
extern int _libx1f4i0_lxfile_stat_else(void *, const char *);
extern int _libx1f4i0_lxfile_stat_file(void *, int);
extern int _libx1f4i0_lxfile_stat_fine(void *, const char *);
extern int _libx1f4i0_lxfile_stat_flat(void *);
extern int _libx1f4i0_lxfile_stat_kate(void *);
extern int _libx1f4i0_lxfile_stat_lift(void *);
extern int _libx1f4i0_lxfile_stat_line(void *);
extern int _libx1f4i0_lxfile_stat_lose(void *);
extern int _libx1f4i0_lxfile_stat_love(void *);
extern int _libx1f4i0_lxfile_stat_miss(void *);
extern int _libx1f4i0_lxfile_stat_node(void *);
extern int _libx1f4i0_lxfile_stat_none(void *, const char *);
extern int _libx1f4i0_lxfile_stat_null(void *);
extern int _libx1f4i0_lxfile_stat_open(void *, const char *);
extern int _libx1f4i0_lxfile_stat_over(void *);
extern int _libx1f4i0_lxfile_stat_peep(void *, long);
extern int _libx1f4i0_lxfile_stat_pipe(void *, const char *);
extern int _libx1f4i0_lxfile_stat_push(void *);
extern int _libx1f4i0_lxfile_stat_rate(void *, long);
extern int _libx1f4i0_lxfile_stat_read(void *);
extern int _libx1f4i0_lxfile_stat_seek(void *);
extern int _libx1f4i0_lxfile_stat_side(void *);
extern int _libx1f4i0_lxfile_stat_size(void *, long);
extern int _libx1f4i0_lxfile_stat_skip(void *, long);
extern int _libx1f4i0_lxfile_stat_sync(void *);
extern int _libx1f4i0_lxfile_stat_will(void *);
extern int _libx1f4i0_lxfile_stat_zero(void *);
extern int _libx1f4i0_lxfile_t_logique(void *, void *, void **);
extern int _libx1f4i0_lxfile_tile_file
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxfile_type_file(struct x1f4_nodetype_type *, int);
extern int _libx1f4i0_lxfile_vset_file(void *, void **);
extern int _libx1f4i0_lxfile_w_pending(void *, void *, void **);
extern int _libx1f4i0_lxfile_wrap_file(void *, struct x1f4_indexset_type *);
extern int _libx1f4i0_lxfile_y_forward(void *, void *, void **);

#endif				/* __LIBx1f4_lxfile_inter_H__ */
