/*
 * lxline-a.j.c
 * Copyright (C) 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxline-types.h>
#include <lxrail.h>
#include <progress.h>

static const struct x1f4_progress_type progress_0 = {
/* *INDENT-OFF* */
    {	"rsk_greater(;*, ;0, ;0)",	2,	0,	1,	23	},
    {	"r_first(;*, ;0)",		1,	0,	1,	15	},
	X1f4_E4_TEXT,	0,		0,	1
/* *INDENT-ON* */
}, progress_1 = {
/* *INDENT-OFF* */
    {	"rs_greater(;1, ;*, ;0, ;0)",	2,	1,	1,	26	},
    {	"rs_first(;1, ;*, ;0)",		1,	1,	1,	20	},
	X1f4_E4_TEXT,	X1f4_E4_CASE,	0,	2
/* *INDENT-ON* */
}, progress_2 = {
/* *INDENT-OFF* */
    {	"rcsik_greater(;*, ;0)",	1,	0,	1,	21	},
    {	"rc_first(;*, ;0)",		1,	0,	1,	16	},
	X1f4_E4_TEXT,	0,		0,	1
/* *INDENT-ON* */
}, progress_3 = {
/* *INDENT-OFF* */
    {	"rcsi_greater(;1, ;*, ;0)",	1,	1,	1,	24	},
    {	"rcs_first(;1, ;*, ;0)",	1,	1,	1,	21	},
	X1f4_E4_TEXT,	X1f4_E4_CASE,	0,	2
/* *INDENT-ON* */
};

int
x1f4_pass_lxline(void *lxline, struct x1f4_progress_type **progress,
		 char **copy)
{
    int status;

    status = _libx1f4i0_lxrail_pass_type
	(__types_rail(lxline), progress, copy, &progress_0, &progress_1,
	 "rs_g_", 5, "(;1, ;*, ;0, ;0)", 16);
    if (status) {
    } else {
	int data;

	data = ((struct lxline_type *) lxline)->link_i.data;
	if (data ^ -1) {
	    struct x1f4_progress_type progress_c, progress_d;

	    progress_c = progress_2;
	    progress_d = progress_3;

	    progress_c.arg1 = data;
	    progress_d.arg1 = data;

	    status = _libx1f4i0_lxrail_pass_type
		(__types_rail(lxline), progress, copy, &progress_c,
		 &progress_d, "rcsi_g_", 7, "(;1, ;*, ;0)", 12);
	}
    }

    return status;
}
