/*
 * lxline-k.i.c
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <copy.h>
#include <e4.h>
#include <fd.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

int
_libx1f4i0_lxline_i_keeping(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    void *data;

    cxbend_data = context;

    lxline_data = cxbend_data->line;

    dxline_data = I_LINE(input[1]);

    status = cxbend_data->pick(dxline_data->line, &data);
    if (status) {
	status = _libx1f4i0_lxline_stat_line(lxline_data, 0, status);
    } else {
	unsigned call, type;

	type = effect_type(data);
	call = *((struct x1f4_function_type *)
		 ((void **) input[-1])[X1f4_E4_RENDITION])->args;
	if (type != call) {
	    status = _libx1f4i0_lxline_stat_ends
		(lxline_data, cxbend_data->bend, type, call);
	} else {
	    unsigned link;

	    link = effect_link(data);

	    do {
		if (~link) {
		    struct lxtext_type *lxtext_data;

		    lxtext_data = lxline_data->link_f.text;
		    lxtext_data += link;
		    if (lxtext_data->lxtype.push) {
			status = lxtext_data->lxtype.push
			    (lxtext_data->lxtype.context, *input,
			     I_USER(byte(data) + 8), lock_excase(dxline_data));
			if (status) {
			    break;
			}
		    } else {
			copy_miss(*input, type, byte(data) + 8);
		    }

		    link_effect(data, ~0);
		} else {
		    copy_miss(*input, type, byte(data) + 8);
		}

		status = cxbend_data->slip(dxline_data->line);
		if (status) {
		    status =
			_libx1f4i0_lxline_stat_line(lxline_data, 0, status);
		} else {
		    dxline_data->size--;
		}
	    } while (0);
	}
    }

    return status;
}
