/*
 * lxline-m.q.c
 * Copyright (C) 2008-2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (output);							      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxline_q_class_m(void *context, void *output, void **input)
{
    int status;
    struct dxline_type *dxline_data;
    struct lxtext_type *lxtext_data;
    void *data;

    lxtext_data = context;

    dxline_data = I_LINE(input[0]);

    status = _libx1f4i0_find_sfnote
	(dxline_data->line, I_TEXT(input[1]), &data);
    if (status) {
	unsigned type;

	status = 0;

	type = effect_type(data);
	if (type != X1f4_E4_MODE) {
	    status = _libx1f4i0_lxline_stat_type
		(lxtext_data->text, I_TEXT(input[1]), type, X1f4_E4_MODE);
	} else {
	    l_MODE(I_MODE(byte(data) + 8), output);
	}
    } else {
	status = _libx1f4i0_lxline_stat_miss
	    (lxtext_data->text, I_TEXT(input[1]));
    }

    return status;
}
