/*
 * lxline-m.r.c
 * Copyright (C) 2008-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))
#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxline_r_class_m(void *context, void *output, void **input)
{
    X1f4_E4_C_TEXT fail;
    int status;
    struct dxline_type *dxline_data;
    struct lxline_type *lxline_data;
    struct lxtext_type *lxtext_data;
    void *data;

    dxline_data = I_LINE(input[0]);

    lxtext_data = context;

    lxline_data = lxtext_data->text;

    fail = I_TEXT(input[1]);

    status = _libx1f4i0_find_sfnote(dxline_data->line, fail, &data);
    if (status) {
	do {
	    unsigned link;

	    link = effect_link(data);
	    if (~link) {
		int (*free)(void *, void *, struct excase_type **,
			    const struct excase_type *);
		struct lxtext_type *lxtext_link;

		lxtext_link =
		    (struct lxtext_type *) lxline_data->link_f.text + link;

		free = lxtext_link->lxtype.free;
		if (free) {
		    status = free
			(lxtext_link->lxtype.context, I_USER(byte(data) + 8),
			 NULL, lock_excase(dxline_data));
		    if (status) {
			break;
		    }
		} else {
		    status = 0;
		}
	    } else {
		status = 0;
	    }

	    l_MODE(I_MODE(input[2]), byte(data) + 8);
	    if (0) {
	    } else {
		unsigned type;

		type = X1f4_E4_MODE;

		type_effect(data, type);

		link_effect(data, ~0);
	    }
	} while (0);
    } else {
	status = _libx1f4i0_lxline_stat_miss(lxline_data, fail);
    }

    return status;
}
