/*
 * lxline-m.x.0.c
 * Copyright (C) 2008-2014, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxline-config.h>

#include <e4.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

#define I_LINE(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))

#define l_MODE(e, output) \
    {									      \
	X1f4_E4_C_MODE *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

int
_libx1f4i0_lxline_x0class_m(void *context, void *output, void **input)
{
    int status;
    struct cxbend_type *cxbend_data;
    struct dxline_type *dxline_data;
    void *data;

    cxbend_data = context;

    dxline_data = I_LINE(input[0]);

    status = cxbend_data->pick(dxline_data->line, &data);
    if (status) {
	status = _libx1f4i0_lxline_stat_line(cxbend_data->line, 0, status);
    } else {
	unsigned type;

	type = effect_type(data);
	if (type != X1f4_E4_MODE) {
	    status = _libx1f4i0_lxline_stat_ends
		(cxbend_data->line, cxbend_data->bend, type, X1f4_E4_MODE);
	} else {
	    X1f4_E4_C_MODE fast;

	    fast = I_MODE(byte(data) + 8);

	    status = cxbend_data->slip(dxline_data->line);
	    if (status) {
		status = _libx1f4i0_lxline_stat_line
		    (cxbend_data->line, 0, status);
	    } else {
		dxline_data->size--;

		if (0) {
		} else {
		    l_MODE(fast, output);
		}
	    }
	}
    }

    return status;
}
