/*
 * lxlist-a.j.c
 * Copyright (C) 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxlist-types.h>
#include <progress.h>

static const struct x1f4_progress_type progress_1 = {
/* *INDENT-OFF* */
    {	"lt_next(;1, ;*, ;0)",		1,	1,	1,	19	},
    {	"lt_first(;1, ;*, ;0)",		1,	1,	1,	20	},
	X1f4_E4_MODE,	X1f4_E4_CASE,	0,	2
/* *INDENT-ON* */
};

int
x1f4_pass_lxlist(void *lxlist, struct x1f4_progress_type **progress)
{
    int type;
    struct x1f4_progress_type *progress_data;

    type = ((struct lxlist_type *) lxlist)->link_t.datatype[0].type;

    progress_data = *progress;

    *progress_data = progress_1;
    progress_data->type = type;
    progress_data++;

    *progress = progress_data;

    return 0;
}
