/*
 * lxlist-a.q.c
 * Copyright (C) 2008, 2009, 2010, 2011, 2013, 2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_list.h>
#include <lxlist-drive.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

#define way_red(context)		((void **) (context))

static int lime_list(void *, void *);

static int
lime_list(void *context, void *data)
{
    int status;
    unsigned link;

    link = effect_link(data);
    if (~link) {
	int (*move)(void *, void *, const struct excase_type *,
		    const struct excase_type *);
	struct lxtext_type *lxtext_data;

	lxtext_data = (struct lxtext_type *)
	    ((struct lxlist_type *) way_red(context)[1])->link_f.text + link;

	move = lxtext_data->lxtype.move;
	if (move) {
	    status = move
		(lxtext_data->lxtype.context,
		 I_USER(byte(data) + 8), way_red(context)[2],
		 way_red(context)[3]);
	} else {
	    status = 0;
	}
    } else {
	status = 0;
    }

    return status;
}


int
_libx1f4i0_lxlist_down_list(void *subtext, void *excase, void *dxlist)
{
    int status;
    void *way_red[4];

    way_red[1] = subtext;
    way_red[2] = excase;
    way_red[3] = lock_excase(dxlist);

    status = _libx1f4i0_lime_l4list
	(((const struct dxlist_type *) dxlist)->list, way_red, lime_list);

    return status;
}
