/*
 * lxlist-n.c.c
 * Copyright (C) 2008-2011, 2013, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxlist-config.h>

#include <stddef.h>

#include <e4.h>
#include <l_list.h>
#include <lxcall.h>
#include <lxlist-inter.h>
#include <lxlist-types.h>

#define I_LIST(t)			(*((X1f4_E4_C_USER *) (t)))

#define dxlist(dxlist) \
    ((struct dxlist_type *) (dxlist))

int
_libx1f4i0_lxlist_c_nearest(void *context, void *output, void **input)
{
    int status;
    struct dxlist_type *dxlist_data, *dxlist_text;

    dxlist_data = I_LIST(input[0]);
    dxlist_text = I_LIST(input[1]);

    if (dxlist_data == dxlist_text) {
	status = 0;
    } else {
	void *dxtext;

	status = _libx1f4i0_lxlist_line_list(context, &dxtext);
	if (status) {
	} else {
	    void *becca[3];

	    becca[0] = context;
	    becca[2] = dxlist_data;

	    status = _libx1f4i0_line_l4list
		(dxlist(dxtext)->list, dxlist_text->list,
		 _libx1f4i0_lxlist_link_link, _libx1f4i0_lxlist_free_link,
		 becca);
	    if (status) {
		status = _libx1f4i0_lxlist_stat_list(context, 0, status);
	    } else {
		dxlist(dxtext)->size = dxlist_text->size;

		status = _libx1f4i0_lxlist_null_list
		    (context, NULL, dxlist_data);
		if (status) {
		} else {
		    status = _libx1f4i0_lxlist_swap_list(dxtext, dxlist_data);
		}
	    }

	    if (1) {
		int excess;

		excess = _libx1f4i0_lxlist_flat_list(context, &dxtext);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }
	}
    }

    return status;
}
