/*
 * lxport-x.u.c
 * Copyright (C) 2010-2011, 2014, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <sys/types.h>
#include <sys/wait.h>

#include <lxcall.h>
#include <lxport-inter.h>
#include <lxport-types.h>

#define lxport(lxport) \
    ((struct lxport_type *) (lxport))

int
x1f4_join_lxport(void *lxport)
{
    int status = 0;

    while (1) {
	struct waitlink_type *waitlink_data;

	waitlink_data = lxport(lxport)->link_u.wait;
	if (waitlink_data) {
	    int effect, excess;
	    pid_t wait;

	    wait = waitpid(waitlink_data->port, &effect, 0);
	    if (waitlink_data->port ^ wait) {
		excess = _libx1f4i0_lxport_stat_call(lxport, "wait", 4);
		status = _libx1f4i0_lxcall_land_slip(excess, status);
		_libx1f4i0_lxport_lose_port(lxport, waitlink_data, NULL);
	    } else {
		excess = _libx1f4i0_lxport_lose_port
		    (lxport, waitlink_data, &effect);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }
	} else {
	    break;
	}
    }

    return status;
}
