/*
 * lxrail-s.j.c
 * Copyright (C) 2011-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <e4.h>
#include <lxcall.h>
#include <lxrail-types.h>

#define I_USER(t)			(*((X1f4_E4_C_USER *) (t)))

int
_libx1f4i0_lxrail_slip_roll(void *roll)
{
    int status = 0;
    struct affect_type *affect_data;
    struct affine_type *affine_data;
    struct lxtext_type *lxtext_data;
    struct x1f4_nodelink_type *nodelink_data;
    unsigned miss;

    affine_data = roll;

    affect_data = (void *) (affine_data + 1);

    nodelink_data = affine_data->nodelink_data;
    lxtext_data = affine_data->lxtext_data;

    miss = affine_data->miss;
    for (; miss; miss--) {
	int link;

	link = affect_data->link;
	if (~link) {
	    int excess, (*free)(void *, void *, struct x1f4_nodelink_type **,
				const struct x1f4_nodelink_type *);
	    struct lxtext_type *lxtext_slip;

	    lxtext_slip = lxtext_data + link;

	    free = lxtext_slip->lxtype.free;
	    if (free) {
		excess = free
		    (lxtext_slip->lxtype.context, I_USER(&affect_data->fxdata),
		     NULL, nodelink_data);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }
	}

	affect_data++;
    }

    return status;
}
