/*
 * lxroll-e.k.c
 * Copyright (C) 2010-2017, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxroll-defs.h>
#include <lxroll-inter.h>
#include <lxroll-types.h>
#include <lxwide.h>

static int
init_roll(void **lxroll, unsigned bits, struct x1f4_lxwide_type *lxwide_data,
	  unsigned tile, const void *data, unsigned flags,
	  struct screen_type *screen_data)
{
    if (1) {
	screen_data->lock_v = lxwide_data->autolink_set;
    }

    if (bits & X1f4_LXWIDE_CODELINK) {
	if (flags & CODELINK_LINK) {
	} else {
	    flags |= CODELINK_LINK;
	    screen_data->lock_w = lxwide_data->codelink_set;
	}
    }

    if (bits & X1f4_LXWIDE_RESOURCE) {
	if (flags & RESOURCE_LINK) {
	} else {
	    flags |= RESOURCE_LINK;
	    screen_data->lock_m = lxwide_data->resource_set;
	}
    }

    if (bits & X1f4_LXWIDE_TEXTFLAT) {
	if (flags & TEXTFLAT_LINK) {
	} else {
	    flags |= TEXTFLAT_LINK;
	    screen_data->lock_e = lxwide_data->textflat_set;
	}
    }

    return _libx1f4i0_lxroll_init_roll(lxroll, flags, screen_data);
}


int
x1f4_tile_lxroll(void **lxroll, unsigned bits,
		 struct x1f4_lxwide_type *lxwide_data, unsigned tile,
		 const void *data)
{
    int status;

    do {
	int type;
	struct screen_type screen;
	unsigned flags;

	if (data) {
	    screen = *(const struct screen_type *) data;
	}

	flags = tile;

	if (x1f4_mind_lxwide(&type, lxwide_data, "file", 4)) {
	    screen.link_i.file = type;
	} else {
	    status = 1;
	    if (1) {
		break;
	    }
	}

	status = init_roll
	    (lxroll, bits, lxwide_data, tile, data, flags, &screen);
    } while (0);

    return status;
}
